/*
 * parse.c: handles messages from the server.   Believe it or not.  I
 * certainly wouldn't if I were you. 
 *
 * Written By Michael Sandrof
 *
 * Copyright(c) 1990 
 *
 * See the COPYRIGHT file, or do a HELP IRCII COPYRIGHT 
 */
#define COMPAT_27

#include "irc.h"

#include "alias.h"
#include "server.h"
#include "names.h"
#include "vars.h"
#include "ctcp.h"
#include "hook.h"
#include "edit.h"
#include "ignore.h"
#include "whois.h"
#include "lastlog.h"
#include "ircaux.h"
#include "funny.h"
#include "crypt.h"
#include "ircterm.h"
#include "flood.h"
#include "window.h"
#include "screen.h"
#include "output.h"
#include "numbers.h"
#include "parse.h"
#include "notify.h"
#include "status.h"
#include "list.h"
#include "userlist.h"
#include "pluto.h"
#include "bot.h"
#include "misc.h"
#include "whowas.h"

#define STRING_CHANNEL '+'
#define MULTI_CHANNEL '#'
#define LOCAL_CHANNEL '&'

#define space ' '
#define	MAXPARA	15	/* Taken from the ircd */

extern	char	forwardnick[];
static	void	strip_modes _((char *, char *, char *));

extern char * do_nslookup _((char *));
extern void do_newuser _((char *, char *, char *));
extern char * random_str _((int, int));
extern char *msgcdcc _((char *, char *, char *));

extern char *channel_key _((char *));
extern char *last_msg;


/*
 * joined_nick: the nickname of the last person who joined the current
 * channel 
 */
	char	*joined_nick = NULL;

/* public_nick: nick of the last person to send a message to your channel */
	char	*public_nick = NULL;

/* User and host information from server 2.7 */
	char	*FromUserHost = empty_string;

/* doing a PRIVMSG */
	int	doing_privmsg = 0;
	int	chan_who = 0;
	
	int	who_on_join = 0;
	
extern	int	sed;
extern	int	in_e_nick;


void fake _((void)) 
{
	bitchsay("--- Fake Message recieved!!! ---");
	return;
}


int annoy_kicks(int list_type, char *to, char *from, char *ptr)
{
int kick_em = 0;

	if ((strchr(ptr, '\002') || strchr(ptr, '\007')
		|| strchr(ptr, '\026') || strchr(ptr, '\037')
		|| caps_fucknut(ptr))
		&& !is_chanop(to, from) && check_channel_match(get_string_var(PROTECT_CHANNELS_VAR), to))
	{
		if (you_is_opped(to))
		{
			if (strchr(ptr, '\002'))
				send_to_server("KICK %s %s :%s",
	    			to, from, "autokick for \002bold\002");
			else if (strchr(ptr, '\007'))
				send_to_server("KICK %s %s :%s",
				to, from, "autokick for beeping\007");
			else if (strchr(ptr, '\037'))
				send_to_server("KICK %s %s :%s",
				to, from, "autokick for \037underline\037");
			else if (strchr(ptr, '\026'))
				send_to_server("KICK %s %s :%s",
				to, from, "autokick for \026inverse\026");
			else {
				send_to_server("KICK %s %s :%s",
				to, from, "autokick for CAPS LOCK");
			}
			kick_em = 1;
		}
	}
	if (strstr(ptr, "0000027fed") && you_is_opped(to))
	{
		char *host = NULL, *p;
		malloc_strcpy(&host, FromUserHost);
		p = strchr(host, '@'); *p++ = '\0';
		send_to_server("MODE %s -o+b %s *!*%s",
		    to, from, cluster(FromUserHost));
		send_to_server("KICK %s %s :%s",
		    to, from, "\002Zmodem rocks\002");
		new_free(&host);
		kick_em = 1;
	}
	if (ban_words)
	{
		WordKickList *word;
		for (word = ban_words; word; word = word->next)
		{
			if (strstr(ptr, word->string))
			{
				if (match(word->channel, to) && you_is_opped(to))
					send_to_server("KICK %s %s :%s %s", to, from, "\002BitchX BWK\002: ", word->string);
			}
		}
	}
	return kick_em;
}

int ctcp_flood_check(char *to, char *from, char *ptr)
{
int old_window_display;
char *fromhost;
char fromusercopy[BIG_BUFFER_SIZE];
char ignorestuff[BIG_BUFFER_SIZE];

	if (strchr(ptr, '\001'))
		if (strchr(strchr(ptr, '\001') + 1, '\001'))
		{
			strcpy(fromusercopy, FromUserHost);
			fromhost = strchr(fromusercopy, '@');
			if (fromhost)
			{
				*fromhost++ = '\0';
				sprintf(ignorestuff, "*@%s ALL -CRAP -PUBLIC",
					cluster(fromhost));
				put_it("\002*** Ignoring %s!%s for CTCP flooding\002",
					from, FromUserHost);
				old_window_display = window_display;
				window_display = 0;
				ignore(NULL, ignorestuff, ignorestuff);
				window_display = old_window_display;
				if (!is_chanop(to, from) && *to == '#')
				{
				    if (you_is_opped(to))
				    {
					send_to_server("MODE %s -o+b %s *!*@%s",
						to, from, cluster(fromhost));
					send_to_server("KICK %s %s :%s",
						to, from, "\002CTCP flood..\002");
					return 1;
				    }
				}
			}
		}
	return 0;
}


/*
 * is_channel: determines if the argument is a channel.  If it's a number,
 * begins with MULTI_CHANNEL and has no '*', or STRING_CHANNEL, then its a
 * channel 
 */
int
is_channel(to)
char	*to;
{
	int	version;

	version = get_server_version(from_server);
        return ( (*to == MULTI_CHANNEL)
                 || (
 #ifdef COMPAT_27
                     version > Server2_7 &&
 #endif
			                     *to == LOCAL_CHANNEL)
                || (version == Server2_8 && *to == '0'));
}


char	* PasteArgs(Args, StartPoint)
	char	**Args;
	int	StartPoint;
{
	int	i;

	for (; StartPoint; Args++, StartPoint--)
		if (!*Args)
			return NULL;
	for (i = 0; Args[i] && Args[i+1]; i++)
		Args[i][strlen(Args[i])] = ' ';
	Args[1] = NULL;
	return Args[0];
}

/*
 * BreakArgs: breaks up the line from the server, in to where its from,
 * setting FromUserHost if it should be, and returns all the arguements
 * that are there.   Re-written by phone, dec 1992.
 */
static	void BreakArgs(Input, Sender, OutPut)
	char	*Input;
	char	**Sender;
	char	**OutPut;
{
	int	ArgCount = 0;

	/*
	 * The RFC describes it fully, but in a short form, a line looks like:
	 * [:sender[!user@host]] COMMAND ARGUMENT [[:]ARGUMENT]{0..14}
	 */

	/*
	 * Look to see if the optional :sender is present.
	 */
	if (*Input == ':')
	{
		*Sender = ++Input;
		while (*Input && *Input != space)
			Input++;
		if (*Input == space)
			*Input++ = 0;

		/*
		 * Look to see if the optional !user@host is present.
		 */
		FromUserHost = *Sender;
		while (*FromUserHost && *FromUserHost != '!')
			FromUserHost++;
		if (*FromUserHost == '!')
			*FromUserHost++ = 0;
	}
	/*
	 * No sender present.
	 */
	else
		*Sender = FromUserHost = empty_string;

	/*
	 * Now we go through the argument list...
	 */
	for (;;)
	{
		while (*Input && *Input == space)
			Input++;

		if (!*Input)
			break;

		if (*Input == ':')
		{
			OutPut[ArgCount++] = ++Input;
			break;
		}

		OutPut[ArgCount++] = Input;
		if (ArgCount >= MAXPARA)
			break;

		while (*Input && *Input != space)
			(void) *Input++;
		if (*Input == space)
			*Input++ = 0;
	}
	OutPut[ArgCount] = NULL;
}

/* in response to a TOPIC message from the server */
static	void
p_topic(from, ArgList)
	char	*from,
		**ArgList;
{
ChannelList *tmp;
	if (!ArgList[1])
		{ fake(); return; }
	tmp = lookup_channel(ArgList[0], from_server, CHAN_NOUNLINK);
	update_stats(TOPICLIST, ArgList[0], from, tmp, 0);			
	if (check_ignore(from, FromUserHost, IGNORE_CRAP) != IGNORED)
	{
		message_from(ArgList[0], LOG_CRAP);
		if (do_hook(TOPIC_LIST, "%s %s %s", from, ArgList[0], ArgList[1]))
			say("%s has changed the topic on channel %s to %s",
				from, ArgList[0], ArgList[1]);
		message_from(NULL, LOG_CURRENT);
	}

}

static	void
p_wallops(from, ArgList)
	char	*from,
		**ArgList;
{
	char	*line;
	int	from_server = index(from, '.') ? 1 : 0;
	if (!(line = PasteArgs(ArgList, 0)))
		{ fake(); return; }

	if (from_server || check_flooding(from, WALLOP_FLOOD,line))
	{
	/* The old server check, don't use the whois stuff for servers */
		int	level;
		char	*high;

                switch (check_ignore(from, FromUserHost, IGNORE_WALLOPS))
                {
                        case (IGNORED):
                                return;
                        case (HIGHLIGHTED):
                                high = highlight_char;
                                break;
                        default:
                                high = empty_string;
                                break;
                }
		message_from(from, LOG_WALLOP);
		level = set_lastlog_msg_level(LOG_WALLOP);
		if (do_hook(WALLOP_LIST, "%s %c %s", from, from_server ? 'S': '*',line))
			put_it("%s!%s%s!%s %s", high, from, from_server ? "" : "*", high, line);
		if (beep_on_level & LOG_WALLOP)
			beep_em(1);
		set_lastlog_msg_level(level);
		message_from(NULL, LOG_CRAP);
	}
}

/*ARGSUSED*/
void
whoreply(from, ArgList)
	char	**ArgList,
		*from;
{
	static	char	format[40];
	static	int	last_width = -1;
	int	ok = 1, voice, opped;
	char	*channel,
		*user,
		*host,
		*server,
		*nick,
		*stat,
		*name;

	FILE	*fip;
	char	buf_data[BIG_BUFFER_SIZE+1];

	if (!ArgList[5])
		{ fake(); return; }

	if (last_width != get_int_var(CHANNEL_NAME_WIDTH_VAR))
	{
		if ((last_width = get_int_var(CHANNEL_NAME_WIDTH_VAR)) != 0)
		    sprintf(format, "%%-%u.%us %%-9s %%-3s %%s@%%s (%%s)",
					(unsigned char) last_width,
					(unsigned char) last_width);
		else
		    strcpy(format, "%s\t%-9s %-3s %s@%s (%s)");
	}
	channel = ArgList[0];
	user = ArgList[1];
	host = ArgList[2];
	server = ArgList[3];
	nick = ArgList[4];
	stat = ArgList[5];
	PasteArgs(ArgList, 6);


	strcpy(buf_data, user);
	strcat(buf_data, "@");
	strcat(buf_data, host);
	voice = (strchr(stat, '+') != NULL); 
	opped = (strchr(stat, '@') != NULL); 

	if (*stat == 'S')	/* this only true for the header WHOREPLY */
	{
		channel = "Channel";
		if (((who_mask & WHO_FILE) == 0) || (fopen (who_file, "r")))
		{
			if (do_hook(WHO_LIST, "%s %s %s %s %s %s %s", channel,
					nick, stat, user, host, server, ArgList[6]))
				put_it(format, channel, nick, stat, user,
					host, ArgList[6]);
			return;
		}
	} 

	name = ArgList[6];

	add_to_channel(channel, nick, from_server, opped, voice, buf_data, server, stat);


	if (who_mask)
	{
		if (who_mask & WHO_HERE)
			ok = ok && (*stat == 'H');
		if (who_mask & WHO_AWAY)
			ok = ok && (*stat == 'G');
		if (who_mask & WHO_OPS)
			ok = ok && (*(stat + 1) == '*');
		if (who_mask & WHO_LUSERS)
			ok = ok && (*(stat + 1) != '*');
		if (who_mask & WHO_CHOPS)
			ok = ok && ((*(stat + 1) == '@') ||
			(*(stat + 2) == '@'));
		if (who_mask & WHO_NAME)
			ok = ok && wild_match(who_name, user);
		if (who_mask & WHO_NICK)
			ok = ok && wild_match(who_nick, nick);
		if (who_mask & WHO_HOST)
			ok = ok && wild_match(who_host, host);
		if (who_mask & WHO_REAL)
			ok = ok && wild_match(who_real, name);
		if (who_mask & WHO_SERVER)
			ok = ok && wild_match(who_server, server);
		if (who_mask & WHO_FILE)
		{
			ok = 0;
			cannot_open = NULL;
			if ((fip = fopen (who_file, "r")) != NULL)
			{
				while (fgets (buf_data, BUFSIZ, fip) !=	NULL)
				{
					buf_data[strlen(buf_data)-1] = '\0';
					ok = ok || wild_match(buf_data, nick);
				}
				fclose (fip);
			} else
				cannot_open = who_file;
		}
	}
	if (ok)
	{
		if (check_sync(-1, channel, NULL) == 0 || who_on_join)
			return;
		if (do_hook(WHO_LIST, "%s %s %s %s %s %s %s", channel, nick,
				stat, user, host, name, server))
		{
			if (get_int_var(SHOW_WHO_HOPCOUNT_VAR))
				put_it(format, channel, nick, stat, user, host, name);
			else
			{
				char	*tmp;

				if ((tmp = (char *) index(name, ' ')) != NULL)
					tmp++;
				else
					tmp = name;
				put_it(format, channel, nick, stat, user, host, tmp);
			}
		}
	}
}

static	void
p_privmsg(from, Args)
	char	*from,
		**Args;
{
	int	level,
		list_type,
		flood_type,
		log_type,
		do_beep_msg = 0;
	unsigned char	ignore_type;
	char	*ptr,
		*to;
	char	*high;
	int	no_flood;
	static int com_do_log, com_lines = 0;
	
	ChannelList *channel = NULL;
	NickList *tmpnick = NULL;
	
	if (!from)
		return;
	PasteArgs(Args, 1);
	to = Args[0];
	ptr = Args[1];
	if (!to || !ptr)
		{ fake(); return; }

	if (is_channel(to) && im_on_channel(to))
	{
		message_from(to, LOG_MSG);
		malloc_strcpy(&public_nick, from);
		log_type = LOG_PUBLIC;
		ignore_type = IGNORE_PUBLIC;
		flood_type = PUBLIC_FLOOD;
		if (!is_on_channel(to, from_server, from))
			list_type = PUBLIC_MSG_LIST;
		else
		{
			if (is_current_channel(to, from_server, 0))
				list_type = PUBLIC_LIST;
			else
				list_type = PUBLIC_OTHER_LIST;
			channel = lookup_channel(to, from_server, CHAN_NOUNLINK);
			if (channel)
				tmpnick = (NickList *)find_in_list((List **)&channel->nicks, from, 0);
		}
	}
	else
	{
		message_from(from, LOG_MSG);
		flood_type = MSG_FLOOD;
		if (my_stricmp(to, get_server_nickname(from_server)))
		{
			log_type = LOG_WALL;
			ignore_type = IGNORE_WALLS;
			list_type = MSG_GROUP_LIST;
		}
		else
		{
			log_type = LOG_MSG;
			ignore_type = IGNORE_MSGS;
			list_type = MSG_LIST;
		}
	}
	switch (check_ignore(from, FromUserHost, ignore_type))
	{
	case IGNORED:
		if ((list_type == MSG_LIST) && get_int_var(SEND_IGNORE_MSG_VAR))
			send_to_server("NOTICE %s :%s is ignoring you", from, get_server_nickname(from_server));
		return;
	case HIGHLIGHTED:
		high = highlight_char;
		break;
	default:
		high = empty_string;
		break;
	}
	ptr = do_ctcp(from, to, ptr);
	if (!ptr || !*ptr)
		return;

	update_stats(PUBLICLIST, to, from, channel, 0);

	level = set_lastlog_msg_level(log_type);
	com_do_log = 0;
	if (get_string_var(PUB_LOGSTR_VAR))
	{
		char *temp;
		temp = get_string_var(PUB_LOGSTR_VAR);
		if (*temp && stristr(ptr, temp))
		{
			com_do_log = 1;
			com_lines = 0;
		}
	}
	if (flood_type == PUBLIC_FLOOD)
	{
		if (is_other_flood(channel, tmpnick, PUBLIC_FLOOD) && you_is_opped(channel->channel))
		{
			no_flood = 1;
			send_to_server("KICK %s %s :%s", channel->channel, tmpnick->nick, "\002public flud\002");	
		}
	}
	no_flood = check_flooding(from, flood_type, ptr);

	if ((sed == 1) && (!do_hook(ENCRYPTED_PRIVMSG_LIST,"%s %s %s",from, to, ptr)))
		sed = 0;
	else
	{
#if 0
		if (get_int_var(CTCP_FLOOD_PROTECTION_VAR))
			ctcp_flood_check(to, from, ptr);
#endif
		switch (list_type)
		{
		case PUBLIC_MSG_LIST:
			if (no_flood && do_hook(list_type, "%s %s %s", from, to, ptr))
			    put_it("%s(%s/%s)%s %s", high, from, to, high, ptr);
			break;
		case MSG_GROUP_LIST:
			if (no_flood && do_hook(list_type, "%s %s %s", from, to, ptr))
			    put_it("%s-%s:%s-%s %s", high, from, to, high, ptr);
			break;
		case MSG_LIST:
			if (!no_flood)
				break;
			malloc_strcpy(&recv_nick, from);
			if (away_set)
			{
				beep_em(get_int_var(BEEP_WHEN_AWAY_VAR));
				set_int_var(MSGCOUNT_VAR, get_int_var(MSGCOUNT_VAR)+1);
			}
			logmsg(0, "*", from, ptr, FromUserHost, 0);
			if (last_msg) new_free(&last_msg); last_msg = NULL;
	
			last_msg = m_sprintf("%s *%s* %s %s <[%s]:%s>", high, from, high, ptr, update_clock(GET_TIME), FromUserHost);

			if ((msgcdcc(from, to, ptr)) == NULL)
				break;

		    if (forwardnick[0])
			send_to_server("NOTICE %s :*%s* %s", forwardnick, from, ptr);
			if (do_hook(list_type, "%s %s", from, ptr))
			{
			    if (away_set && !get_int_var(LONG_MSG_VAR))
				put_it("%s*%s*%s %s <%.16s>", high, from, high, ptr, update_clock(GET_TIME));
			    else if (get_int_var(LONG_MSG_VAR))
				put_it("\026 *%s* \026 %s <[%s]:%s>", from, ptr,
					update_clock(GET_TIME), FromUserHost);
			    else
				put_it("%s*%s*%s %s", high, from, high, ptr);
			}
			break;
		case PUBLIC_LIST:
		{
			if (get_int_var(ANNOY_KICK_VAR))
                		annoy_kicks(list_type, to, from, ptr);
			doing_privmsg = 1;
			if (com_do_log || com_lines)
			{
				com_lines++;
				if (com_lines == 5)
					com_lines = 0;
				logmsg(0, "<", from, ptr, FromUserHost, 0);
			}
			if (no_flood && do_hook(list_type, "%s %s %s", from, to, ptr))
			{
				char *theshit;
				char *LAME;
				theshit = get_string_var(PUB_LOGSTR_VAR);
				if (get_int_var(EGO_VAR) && stristr(ptr, 
					theshit) && *theshit)
					LAME = convert(ptr);
				else
					LAME = ptr;
				put_it("<%c%s%c> %s", 
				    (do_beep_msg) ? '\026' : '\002', from, 
				    (do_beep_msg) ? '\026' : '\002', LAME);
			}	
			doing_privmsg = 0;
			break;
		}
		case PUBLIC_OTHER_LIST:
			if (get_int_var(ANNOY_KICK_VAR))
	                	annoy_kicks(list_type, to, from, ptr);
			doing_privmsg = 1;
			if (com_do_log || com_lines)
			{
				com_lines++;
				if (com_lines == 5)
					com_lines = 0;
				logmsg(0, "<", from, ptr, FromUserHost, 0);
			}
			if (no_flood && do_hook(list_type, "%s %s %s", from, to, ptr))
			{
	                        char *theshit;
				char *LAME;
				theshit = get_string_var(PUB_LOGSTR_VAR);
                        	if (get_int_var(EGO_VAR) && stristr(ptr,
	                            theshit) && *theshit)
        	                      LAME = convert(ptr);
                	        else
                        	      LAME = ptr;
				put_it("<%c%s:%s%c> %s", 
				    (do_beep_msg) ? '\026' : '\002', from, to, 
				    (do_beep_msg) ? '\026' : '\002', LAME);
			}	
			doing_privmsg = 0;
			break;
		}
	}
	if (beep_on_level & log_type)
		beep_em(1);
	set_lastlog_msg_level(level);
	message_from(NULL, LOG_CURRENT);
}

/*ARGSUSED*/
static	void
p_quit(from, ArgList)
	char	*from,
		**ArgList;
{
	int	one_prints = 0;
	char	*chan = NULL;
	char	*Reason;
	ChannelList *tmpc;
	int netsplit = 0;
	int ignore;
			
	PasteArgs(ArgList, 0);
	if (ArgList[0])
	{
		Reason = ArgList[0];
		netsplit = check_split(from, Reason, chan);
	}
	else
		Reason = "?";
	ignore = check_ignore(from, FromUserHost, IGNORE_CRAP);
	for (chan = walk_channels(from, 1, from_server); chan; chan = walk_channels(from, 0, -1))
	{
		if ((tmpc = lookup_channel(chan, from_server, CHAN_NOUNLINK)))
			update_stats(CHANNELSIGNOFFLIST, chan, from, tmpc, netsplit);
		if (ignore != IGNORED)
		{
			message_from(chan, LOG_CRAP);
			if (do_hook(CHANNEL_SIGNOFF_LIST, "%s %s %s", chan, from, Reason))
				one_prints = 1;
		}
	}
	if (one_prints)
	{
		message_from(what_channel(from, from_server), LOG_CRAP);
		if ((ignore != IGNORED) && do_hook(SIGNOFF_LIST, "%s %s", from, Reason))
			if (!netsplit && !cget_int_var(HACKING_CVAR,what_channel(from, from_server))) 
				say("Signoff: %s (%s)", from, Reason);
	}
	notify_mark(from, 0, 0);
	remove_from_channel(NULL, from, from_server, netsplit, Reason);
	message_from(NULL, LOG_CURRENT);
}

/*ARGSUSED*/
static	void p_pong(char *from, char **ArgList)
{
	if (check_ignore(from, FromUserHost, IGNORE_CRAP) != IGNORED)
		if (ArgList[0] && index(ArgList[0], '.'))
			say("%s: PONG received from %s", ArgList[0], from);
}

/*ARGSUSED*/
static	void
p_error(from, ArgList)
	char	*from,
		**ArgList;
{
	PasteArgs(ArgList, 0);
	if (!ArgList[0])
		{ fake(); return; }
	say("%s", ArgList[0]);
}

#if 0
extern int chan_who;

void add_to_chan_who(WhoisStuff *stuff, char *nick, char *text) 
{
ChannelList *chan = NULL;
NickList *Nick = NULL;

	if (!stuff || !nick || !text)
	{
		return;
	}

	remove_trailing_spaces(stuff->channels);

	for (chan = lookup_channel(stuff->channels, from_server, 0); chan; chan = chan->next)
	{
		if ((Nick = (NickList *) find_in_list((List **)&chan->nicks, nick, 0)))
			malloc_strcpy(&Nick->server,stuff->server);
	}
	return;
}
#endif

static	void p_channel(from, ArgList)
	char	*from;
	char	**ArgList;
{
	char	*channel;
			
	if (!strcmp(ArgList[0], "0"))
		{ fake(); return; }

	channel = ArgList[0];
	message_from(channel, LOG_CRAP);
	malloc_strcpy(&joined_nick, from);
	notify_mark(from, 1, 0);

	if (!my_stricmp(from, get_server_nickname(from_server)))
	{
		add_channel(channel, from_server);
		if (!get_int_var(NAMES_ON_JOIN_VAR))
			funny_set_ignore_channel(channel);
		send_to_server("MODE %s", channel);
		send_to_server("WHO %s", channel);	
		send_to_server("MODE %s b", channel);
		(void)do_hook(JOIN_ME_LIST, "%s", channel);
	}
	else 
	{
		if (get_int_var(AUTO_WHO_ON_JOIN_VAR))
		{
			send_to_server("WHO %s", from);
			who_on_join++;
		}
		add_to_channel(channel, from, from_server, 0, 0, FromUserHost, NULL, NULL);
	}
			
	if (check_sync(-1, channel, NULL) == -1)
		check_auto(channel, from, FromUserHost);

#ifdef I_DONT_TRUST_MY_USERS
	if (!get_channel_oper(channel, from_server))
		in_on_who = 1
#endif

	if (check_ignore(from, FromUserHost, IGNORE_CRAP) != IGNORED)
	{
		char * tmp, *tmp2 = NULL;
		tmp = strchr(FromUserHost, '@');
		tmp++;
		if (get_int_var(AUTO_NSLOOKUP_VAR) && *tmp && isdigit(*(tmp + strlen(tmp) - 1))) 
			tmp2 = do_nslookup(tmp);
		if (do_hook(JOIN_LIST, "%s %s %s", from, channel, tmp2 ? tmp2 : FromUserHost? FromUserHost : "UnKnown"))
		{
			message_from(channel, LOG_CRAP);
			say("%s [%s] has joined channel %s", from,
			    tmp2 ? tmp2 : FromUserHost ? FromUserHost : "UnKnown", channel);
			message_from(NULL, LOG_CURRENT);
		}
#ifdef I_DONT_TRUST_MY_USERS
		in_on_who = 0;
#endif
	}

}

static	void
p_invite(from, ArgList)
	char	*from,
		**ArgList;
{
	char	*high;
	UserList *p = NULL;
	
	switch (check_ignore(from, FromUserHost, IGNORE_INVITES))
	{
		case IGNORED:
			if (get_int_var(SEND_IGNORE_MSG_VAR))
				send_to_server("NOTICE %s :%s is ignoring you",
					from, get_server_nickname(from_server));
			return;
		case HIGHLIGHTED:
			high = highlight_char;
			break;
		default:
			high = empty_string;
			break;
	}
	if (ArgList[0] && ArgList[1])
	{
		message_from(from, LOG_CRAP);
		if (check_flooding(from, INVITE_FLOOD, ArgList[1]) && 
		   do_hook(INVITE_LIST, "%s %s", from, ArgList[1]))
			say("%s%s%s invites you to channel %s", high,
					from, high, ArgList[1]);
		malloc_strcpy(&invite_channel, ArgList[1]);
		if (cget_int_var(AUTO_REJOIN_VAR, invite_channel) && invite_channel && ((p = nickinbot(from, FromUserHost)) != NULL))
			if (check_channel_match(p->channels,invite_channel)) 
				send_to_server("JOIN %s %s", 
					invite_channel, ArgList[2]? ArgList[2]: "");
		malloc_strcpy(&recv_nick, from);
	}
}

#ifdef __STDC__
static void p_silence (char *from, char **ArgList)
#else
static	void	p_silence (from, ArgList)
char	*from,
	**ArgList;
#endif
{
	char *target = ArgList[0];
	char *mag = target++;
	if (do_hook(SILENCE_LIST, "%c %s", mag, target))
	{
		if (*mag == '+')
			say ("You will no longer recieve msgs from %s", target);
		else if (*mag == '-')
			say ("You will now recieve msgs from %s", target);
		else
			say ("Unrecognized silence argument: %s", target);
	}
}


static	void
p_kill(from, ArgList)
	char	*from,
		**ArgList;
{
        char sc[4];

	close_server(from_server,empty_string);
	clean_whois_queue();
	window_check_servers();
	sprintf(sc, "+%i", from_server);

	if (index(from, '.'))
        {
		say("Server [%s] has rejected you (probably due to a nick collision)", from);
        	server (NULL, sc, empty_string);
	}
	else
	{
		int foo;
		foo = do_hook(DISCONNECT_LIST,"Killed by %s (%s)",from,
			ArgList[1] ? ArgList[1] : "(No Reason Given)");

		if (foo)
			say("You have been killed by that fascist [%s] %s", from,
				ArgList[1] ? ArgList[1] : "(No Reason Given)");

		if (!background /*&& get_int_var(AUTO_RECONNECT_VAR)*/)
			server (NULL, sc, empty_string);
	}
}

static	void
p_ping(ArgList)
	char	**ArgList;
{
	PasteArgs(ArgList, 0);
	send_to_server("PONG %s", ArgList[0]);
}

static	void
p_nick(from, ArgList)
	char	*from,
		**ArgList;
{
	int	one_prints = 0,
		its_me = 0,
		fucking_flooder;
	char	*chan;
	char	*line;

	line = ArgList[0];
	if (my_stricmp(from, get_server_nickname(from_server)) == 0){
		if (from_server == primary_server)
			strmcpy(nickname, line, NICKNAME_LEN);
		set_server_nickname(from_server, line);
		its_me = 1;
		in_e_nick = 0;
	}
	if (check_ignore(from, FromUserHost, IGNORE_CRAP)!= IGNORED)
	{
		fucking_flooder = check_flooding(from, NICK_FLOOD, line);
/* CDE walk Channels again */
		for (chan = walk_channels(from, 1, from_server); chan;
				chan = walk_channels(from, 0, -1))
		{
			if (get_int_var(FLOOD_KICK_VAR) && !fucking_flooder)
			{
				if (find_user_level(from, cluster(FromUserHost), chan) >= 90)
					fucking_flooder = 1; else fucking_flooder = 0;					
			}
			if (!fucking_flooder && check_channel_match(get_string_var(PROTECT_CHANNELS_VAR), chan))
			{
			    if(you_is_opped(chan))
			    {
				send_to_server("MODE %s -o+b %s *!*%s", chan,
					line, cluster(FromUserHost));
				send_to_server("KICK %s %s :\002niq flud\002",
					chan, line);
			    }
			}
			message_from(chan, LOG_CRAP);
			if (do_hook(CHANNEL_NICK_LIST, "%s %s %s", chan, from, line))
				one_prints = 1;
		}
		if (one_prints)
		{
			if (its_me)
				message_from(NULL, LOG_CRAP);
			else
				message_from(what_channel(from, from_server), LOG_CRAP);
			if (do_hook(NICKNAME_LIST, "%s %s", from, line))
				say("%s is now known as %s", from, line);
		}
	}
	rename_nick(from, line, from_server);
	notify_mark(from, 0, 0);
	notify_mark(line, 1, 0);
}

static	void p_mode (char *from, char **ArgList)
{
	char	*channel;
	char	*line;
	int	flag;
	
	flag = check_ignore(from, FromUserHost, IGNORE_CRAP);
	PasteArgs(ArgList, 1);
	channel = ArgList[0];
	line = ArgList[1];

	message_from(channel, LOG_CRAP);
	if (channel && line)
	{
		if (get_int_var(MODE_STRIPPER_VAR))
			strip_modes(from,channel,line);
		if (is_channel(channel))
		{
			if (flag != IGNORED && do_hook(MODE_LIST, "%s %s %s",
					from, channel, line))
				say("Mode change \"%s\" on channel %s by %s",
						line, channel, from);
			update_channel_mode(from, channel, from_server, line);
		}
		else
		{
			if (flag != IGNORED && do_hook(MODE_LIST, "%s %s %s",
					from, channel, line))
				say("Mode change \"%s\" for user %s by %s",
						line, channel, from);
			update_user_mode(line);
		}
		update_all_status();
	}
}

#ifdef __STDC__
static void strip_modes (char *from, char *channel, char *line)
#else
static  void    strip_modes (from, channel, line)
char    *from;
char    *channel;
char    *line;
#endif
{
	char	*mode;
	char 	*pointer;
	char	mag = '+'; /* XXXX Bogus */
        char    *copy = NULL;
        char    *free_copy;
	
        malloc_strcpy(&copy, line);
        free_copy = copy;
	mode = next_arg(copy, &copy);
	if (is_channel(channel))
	{
		for (pointer = mode;*pointer;pointer++)
		{
			char	c = *pointer;
			switch (c) {
				case '+' :
				case '-' : mag = c; break;
				case 'l' : if (mag == '+')
						do_hook(MODE_STRIPPED_LIST,"%s %s %c%c %s",
						  from,channel,mag,c,next_arg(copy,&copy));
					   else
						do_hook(MODE_STRIPPED_LIST,"%s %s %c%c",
						  from,channel,mag,c);
					   break;
				case 'a' :
				case 'i' :
				case 'm' :
				case 'n' :
				case 'p' :
				case 's' :
				case 't' : do_hook(MODE_STRIPPED_LIST,"%s %s %c%c",from,
						channel,mag,c);
					   break;
				case 'b' :
				case 'k' :
				case 'o' :
				case 'v' : do_hook(MODE_STRIPPED_LIST,"%s %s %c%c %s",from,
						channel,mag,c,next_arg(copy,&copy));
					   break;
				}
		}
	}
	else /* User mode */
	{
		for (pointer = mode;*pointer;pointer++)
		{
			char	c = *pointer;
			switch (c) {
				case '+' :
				case '-' : mag = c; break;
				default  : do_hook(MODE_STRIPPED_LIST,"%s %s %c%c",from, channel, mag, c);
					   break;
			}
		}
	}
        new_free(&free_copy);
}

static	void
p_kick(from, ArgList)
	char	*from,
		**ArgList;
{
	char	*channel,
		*who,
		*comment;
	char	*chankey = NULL;
	ChannelList *chan = NULL;
	NickList *tmpnick = NULL;

	channel = ArgList[0];
	who = ArgList[1];
	comment = ArgList[2] ? ArgList[2] : "(no comment)";

	chan = lookup_channel(channel, from_server, CHAN_NOUNLINK);
	if (chan)
		tmpnick = (NickList *)find_in_list((List **)&chan->nicks, from, 0);

	message_from(channel, LOG_CRAP);
	if (channel && who)
	{
		update_stats(KICKLIST, channel, from, chan, 0);
		if (my_stricmp(who, get_server_nickname(from_server)) == 0)
		{

			char *username = NULL, *ptr;
			if (channel_key(channel))
				malloc_strcpy(&chankey, channel_key(channel));
			ptr = NULL;
			switch(cget_int_var(AUTO_REJOIN_CVAR, channel))
			{
				case 0:
				case 1:
					break;
				case 2:
					if (FromUserHost && strchr(FromUserHost, '@'))
					{
						malloc_strcpy(&username, FromUserHost);
						*strchr(username, '@') = '\0';
						ptr = username;
						if (ptr && (*ptr == '~'))
							ptr++;
						if (ptr && (*ptr == '#'))
							ptr++;
					}
					do_newuser(NULL, ptr, NULL);
					new_free(&username);
					break;
					
				case 3:
					send_to_server("NICK %s", random_str(3,9));
					break;
				case 4:
					do_newuser(NULL, random_str(2,9), NULL);
				case 5:
				default:
						send_to_server("NICK %s", random_str(3,9));
					break;
			}
			if (cget_int_var(AUTO_REJOIN_CVAR, channel))
				send_to_server("JOIN %s %s", channel, chankey ? chankey: empty_string);
			new_free(&chankey);
			remove_channel(channel, from_server);
			update_all_status();
			if (do_hook(KICK_LIST, "%s %s %s %s", who,
				from, channel, comment?comment:empty_string))
				say("You have been kicked off channel %s by %s (%s)",
					channel, from, comment?comment : "(no comment)");

		}
		else
		{
			if ((check_ignore(from, FromUserHost, IGNORE_CRAP) != IGNORED) && 
			     do_hook(KICK_LIST, "%s %s %s %s", who, from, channel, comment))
				say("%s has been kicked off channel %s by %s (%s)", who, channel, from, comment);
			if (my_stricmp(from, get_server_nickname(from_server)) && is_other_flood(chan, tmpnick, KICK_FLOOD))
			{
				if (you_is_opped(channel) && chan && chan->set_kickflood && tmpnick)
				{
					if (tmpnick->kickcount == chan->set_deop_on_kickflood)
						send_to_server("MODE %s -o %s", channel, from, "\002Mass kick detected - deop\002");
					else 
						send_to_server("KICK %s %s : %s", channel, from, "\002Mass kick detected - kick\002");
				}
			}
			remove_from_channel(channel, who, from_server, 0, NULL);
		}
	}
}

static	void p_part(char *from, char **ArgList)
{
	char	*channel;
	ChannelList *tmpc;
	
	if (!from || !*from)
		return;
	channel = ArgList[0];

	message_from(channel, LOG_CRAP);
	in_on_who = 1;

	tmpc = lookup_channel(channel, from_server, CHAN_NOUNLINK);
	update_stats(LEAVELIST, channel, from, tmpc, 0);

	if ((check_ignore(from, FromUserHost, IGNORE_CRAP) != IGNORED) &&
		do_hook(LEAVE_LIST, "%s %s %s", from, channel, FromUserHost))
			say("%s[%s] has left channel %s", from, FromUserHost, channel);

	if (my_stricmp(from, get_server_nickname(from_server)) == 0)
	{
		remove_channel(channel, from_server);
		remove_from_mode_list(channel, from_server);
	}
	else
		remove_from_channel(channel, from, from_server, 0, NULL);

	in_on_who = 0;
}

void
parse_server(line)
	char	*line;
{
	char	*from,
		*comm,
		*end,
		*copy = NULL;
	int	numeric;
	char	**ArgList;
	char	*TrueArgs[MAXPARA + 1];

	if (!line || !*line)
		return;

	end = strlen(line) + line;
	if (*--end == '\n')
		*end-- = '\0';
	if (*end == '\r')
		*end-- = '\0';

	if (*line == '!')
	{
		if (do_hook(IRCSERV_LIST, "%s", line + 1))
			say("Message from IRCSERV: %s", line + 1);
		return;
	}
	if (*line == ':')
	{
		if (!do_hook(RAW_IRC_LIST, "%s", line + 1))
			return;
	}
	else if (!do_hook(RAW_IRC_LIST, "%s %s", "*", line))
		return;

	malloc_strcpy(&copy, line);
	ArgList = TrueArgs;
	BreakArgs(copy, &from, ArgList);

	if (!(comm = (*ArgList++)))
		return;		/* Empty line from server - ByeBye */

	if (!from)
		return;
		
	/* 
	 * I reformatted these in may '96 by using the output of /stats m
	 * from a few busy servers.  They are arranged so that the most 
	 * common types are high on the list (to save the average number
	 * of compares.)  I will be doing more testing in the future on
	 * a live client to see if this is a reasonable order.
	 */
	if ((numeric = atoi(comm)))
		numbered_command(from, numeric, ArgList);

	/* There are the core msgs for most non-numeric traffic. */
	else if (!strcmp(comm, "PRIVMSG")) 	p_privmsg(from, ArgList);
	else if (!strcmp(comm, "JOIN")) 	p_channel(from, ArgList);
	else if (!strcmp(comm, "NICK")) 	p_nick(from, ArgList);
	else if (!strcmp(comm, "PART")) 	p_part(from, ArgList);
	else if (!strcmp(comm, "MODE")) 	p_mode(from, ArgList);
	else if (!strcmp(comm, "QUIT")) 	p_quit(from, ArgList);
	else if (!strcmp(comm, "NOTICE")) 	parse_notice(from, ArgList);
	else if (!strcmp(comm, "TOPIC")) 	p_topic(from, ArgList);
	else if (!strcmp(comm, "KICK")) 	p_kick(from, ArgList);
	else if (!strcmp(comm, "INVITE")) 	p_invite(from, ArgList);

	/* These are used, but not nearly as much as ones above */
	else if (!strcmp(comm, "WALLOPS")) 	p_wallops(from, ArgList);
	else if (!strcmp(comm, "ERROR")) 	p_error(from, ArgList);
	else if (!strcmp(comm, "ERROR:")) 	p_error(from, ArgList);
	else if (!strcmp(comm, "SILENCE")) 	p_silence(from, ArgList);
	else if (!strcmp(comm, "KILL")) 	p_kill(from, ArgList);
	else if (!strcmp(comm, "PONG")) 	p_pong(from, ArgList);
	else if (!strcmp(comm, "PING")) 	p_ping(ArgList);

	/* Some kind of unrecognized/unsupported command */
	else
	{
		PasteArgs(ArgList, 0);
		if (from)
			say("Odd server stuff: \"%s %s\" (%s)", comm, ArgList[0], from);
		else
			say("Odd server stuff: \"%s %s\"", comm, ArgList[0]);
	}
	new_free(&copy);
	from_server = -1;
}
